// Code generated by mockery v2.20.0. DO NOT EDIT.

package mocks

import (
	hclog "github.com/hashicorp/go-hclog"
	mock "github.com/stretchr/testify/mock"

	pipeline "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-plugin-sdk/framework/pipeline"
)

// Plugin is an autogenerated mock type for the Plugin type
type Plugin struct {
	mock.Mock
}

// Config provides a mock function with given fields:
func (_m *Plugin) Config() (interface{}, error) {
	ret := _m.Called()

	var r0 interface{}
	var r1 error
	if rf, ok := ret.Get(0).(func() (interface{}, error)); ok {
		return rf()
	}
	if rf, ok := ret.Get(0).(func() interface{}); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(interface{})
		}
	}

	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetActions provides a mock function with given fields:
func (_m *Plugin) GetActions() []func() pipeline.Action {
	ret := _m.Called()

	var r0 []func() pipeline.Action
	if rf, ok := ret.Get(0).(func() []func() pipeline.Action); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]func() pipeline.Action)
		}
	}

	return r0
}

// PluginData provides a mock function with given fields: logger
func (_m *Plugin) PluginData(logger hclog.Logger) (interface{}, error) {
	ret := _m.Called(logger)

	var r0 interface{}
	var r1 error
	if rf, ok := ret.Get(0).(func(hclog.Logger) (interface{}, error)); ok {
		return rf(logger)
	}
	if rf, ok := ret.Get(0).(func(hclog.Logger) interface{}); ok {
		r0 = rf(logger)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(interface{})
		}
	}

	if rf, ok := ret.Get(1).(func(hclog.Logger) error); ok {
		r1 = rf(logger)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ValidateConfig provides a mock function with given fields: config
func (_m *Plugin) ValidateConfig(config interface{}) error {
	ret := _m.Called(config)

	var r0 error
	if rf, ok := ret.Get(0).(func(interface{}) error); ok {
		r0 = rf(config)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

type mockConstructorTestingTNewPlugin interface {
	mock.TestingT
	Cleanup(func())
}

// NewPlugin creates a new instance of Plugin. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewPlugin(t mockConstructorTestingTNewPlugin) *Plugin {
	mock := &Plugin{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
